/*
**	$Id: MiscPanel.c,v 1.7 92/08/18 16:11:26 olsen Sta Locker: olsen $
**	$Revision: 1.7 $
**	$Date: 92/08/18 16:11:26 $
**
**	Editing panel for miscellaneous parts of the configuration
**
**	Copyright  1990-1992 by Olaf `Olsen' Barthel & MXM
**		All Rights Reserved
*/

#include "termGlobal.h"

enum	{	GAD_PRIORITY,GAD_OVERRIDE,GAD_BACKUP,GAD_AUTOUPLOAD,GAD_SETBIT,GAD_CLIPBOARD,GAD_CHARDELAY,GAD_LINEDELAY,
		GAD_MAXBUFFSIZE,GAD_BUFFERENABLED,GAD_SHOWFASTMACROS,GAD_USE,GAD_CANCEL };

STATIC STRPTR __saveds
ShowTime(struct Gadget *SomeGadget,WORD Level)
{
	return(LocaleSeconds(Level));
}

STATIC struct Gadget *
CreateAllGadgets(struct Configuration *Config,struct Gadget **GadgetArray,struct Gadget **GadgetList,APTR VisualInfo,UWORD TopEdge)
{
	struct Gadget		*Gadget;
	struct NewGadget	 NewGadget;
	UWORD			 Counter = 0;

	SZ_SizeSetup(Screen,&UserFont,TRUE);

	memset(&NewGadget,0,sizeof(struct NewGadget));

	if(Gadget = CreateContext(GadgetList))
	{
		SZ_AddLeftOffset(SZ_LeftOffsetDelta(MSG_MISCPANEL_PROGRAM_PRIORITY_GAD,MSG_MISCPANEL_SHOW_FAST_MACROS_GAD));

		if(SZ_Width(INTEGER_KIND,NULL,10,NULL) > 140)
			SZ_SetWidth(SZ_Width(INTEGER_KIND,NULL,10,NULL));
		else
			SZ_SetWidth(140);

		NewGadget . ng_GadgetText	= LocaleString(MSG_MISCPANEL_PROGRAM_PRIORITY_GAD);
		NewGadget . ng_TextAttr		= &UserFont;
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_Flags		= PLACETEXT_LEFT;
		NewGadget . ng_VisualInfo	= VisualInfo;

		GadgetArray[Counter++] = Gadget = CreateGadget(SLIDER_KIND,Gadget,&NewGadget,
			SZ_Adjust,		TRUE,
			SZ_AutoWidth,		TRUE,

			GT_Underscore,		'_',
			GTSL_Min,		-128,
			GTSL_Max,		127,
			GTSL_Level,		Config -> Priority,
			GTSL_MaxLevelLen,	4,
			GTSL_LevelFormat,	"%4ld",
			PGA_Freedom,		LORIENT_HORIZ,
			GA_Immediate,		TRUE,
			GA_RelVerify,		TRUE,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_MISCPANEL_OVERRIDE_TRANSFER_PATH_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(CHECKBOX_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,

			GTCB_Checked,	Config -> OverridePath,
			GT_Underscore,	'_',
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_MISCPANEL_BACKUP_CONFIGURATION_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(CHECKBOX_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,

			GTCB_Checked,	Config -> BackupConfig,
			GT_Underscore,	'_',
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_MISCPANEL_USE_AUTO_UPLOAD_PANEL_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(CHECKBOX_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,

			GTCB_Checked,	Config -> AutoUpload,
			GT_Underscore,	'_',
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_MISCPANEL_SET_ARCHIVED_BIT_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(CHECKBOX_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,

			GTCB_Checked,	Config -> SetArchivedBit,
			GT_Underscore,	'_',
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_MISCPANEL_CLIPBOARD_UNIT_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(INTEGER_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,

			GT_Underscore,	'_',
			GTIN_MaxChars,	3,
			GTIN_Number,	Config -> ClipboardUnit,
			GTST_EditHook,	&CommandHook,
			GA_Immediate,	TRUE,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_MISCPANEL_CHAR_DELAY_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(SLIDER_KIND,Gadget,&NewGadget,
			SZ_Adjust,		TRUE,
			SZ_AutoWidth,		TRUE,

			GT_Underscore,		'_',
			GTSL_Min,		0,
			GTSL_Max,		10 * 100,
			GTSL_Level,		Config -> CharDelay,
			GTSL_MaxLevelLen,	6,
			GTSL_LevelFormat,	"%s s",
			GTSL_DispFunc,		ShowTime,
			PGA_Freedom,		LORIENT_HORIZ,
			GA_Immediate,		TRUE,
			GA_RelVerify,		TRUE,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_MISCPANEL_LINE_DELAY_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(SLIDER_KIND,Gadget,&NewGadget,
			SZ_Adjust,		TRUE,
			SZ_AutoWidth,		TRUE,

			GT_Underscore,		'_',
			GTSL_Min,		0,
			GTSL_Max,		10 * 100,
			GTSL_Level,		Config -> LineDelay,
			GTSL_MaxLevelLen,	6,
			GTSL_LevelFormat,	"%s s",
			GTSL_DispFunc,		ShowTime,
			PGA_Freedom,		LORIENT_HORIZ,
			GA_Immediate,		TRUE,
			GA_RelVerify,		TRUE,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_MISCPANEL_MAXIMUM_BUFFER_SIZE_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(INTEGER_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,

			GT_Underscore,	'_',
			GTIN_MaxChars,	8,
			GTIN_Number,	Config -> MaxLogBuffSize,
			GTST_EditHook,	&CommandHook,
			GA_Immediate,	TRUE,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_MISCPANEL_BUFFER_ENABLED_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(CHECKBOX_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,

			GTCB_Checked,	Config -> BufferEnabled,
			GT_Underscore,	'_',
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_MISCPANEL_SHOW_FAST_MACROS_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(CHECKBOX_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,

			GTCB_Checked,	Config -> OpenFastMacroPanel,
			GT_Underscore,	'_',
		TAG_DONE);

		SZ_UpdateMaxWidth(BUTTON_KIND,LocaleString(MSG_GLOBAL_USE_GAD),0,NULL);
		SZ_UpdateMaxWidth(BUTTON_KIND,LocaleString(MSG_GLOBAL_CANCEL_GAD),0,NULL);

		SZ_SetWidth(SZ_ResetMaxWidth());

		NewGadget . ng_GadgetText	= LocaleString(MSG_GLOBAL_USE_GAD);
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_Flags		= 0;

		GadgetArray[Counter++] = Gadget = CreateGadget(BUTTON_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,
			SZ_AlignExtra,	TRUE,
			SZ_AlignLeft,	TRUE,
			SZ_AlignBottom,	TRUE,

			GT_Underscore,	'_',
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_GLOBAL_CANCEL_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(BUTTON_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,
			SZ_AlignRight,	TRUE,

			GT_Underscore,	'_',
		TAG_DONE);
	}

	return(Gadget);
}

VOID
MiscPanel(struct Configuration *Config)
{
	struct Window	*PanelWindow;
	struct Gadget	*GadgetList = NULL;
	struct Gadget	*GadgetArray[GAD_CANCEL + 1];

	CopyMem(Config,&PrivateConfig,sizeof(struct Configuration));

	if(CreateAllGadgets(Config,&GadgetArray[0],&GadgetList,VisualInfo,Screen -> WBorTop + Screen -> Font -> ta_YSize + 1))
	{
		if(PanelWindow = OpenWindowTags(NULL,
			WA_Left,	(Screen -> Width	- SZ_GetWindowWidth())	/ 2,
			WA_Top,		(Screen -> Height	- SZ_GetWindowHeight())	/ 2,
			WA_Width,	SZ_GetWindowWidth(),
			WA_Height,	SZ_GetWindowHeight(),

			WA_Activate,	TRUE,
			WA_DragBar,	TRUE,
			WA_DepthGadget,	TRUE,
			WA_RMBTrap,	TRUE,
			WA_DepthGadget,	TRUE,
			WA_CloseGadget,	TRUE,
			WA_CustomScreen,Screen,

			WA_IDCMP,	IDCMP_GADGETDOWN | IDCMP_ACTIVEWINDOW | IDCMP_VANILLAKEY | IDCMP_CLOSEWINDOW | BUTTONIDCMP | CHECKBOXIDCMP | SLIDERIDCMP | INTEGERIDCMP,

			WA_Title,	LocaleString(MSG_MISCPANEL_MISCELLANEOUS_PREFERENCES_TXT),
		TAG_DONE))
		{
			struct IntuiMessage	*Massage;
			ULONG			 Class,Code;
			struct Gadget		*Gadget;
			BYTE			 Terminated = FALSE;

			PushWindow(PanelWindow);

			AddGList(PanelWindow,GadgetList,(UWORD)-1,(UWORD)-1,NULL);
			RefreshGList(GadgetList,PanelWindow,NULL,(UWORD)-1);
			GT_RefreshWindow(PanelWindow,NULL);

			ActiveGadget = NULL;

			while(!Terminated)
			{
				WaitPort(PanelWindow -> UserPort);

				while(!Terminated && (Massage = (struct IntuiMessage *)GT_GetIMsg(PanelWindow -> UserPort)))
				{
					Class	= Massage -> Class;
					Code	= Massage -> Code;
					Gadget	= (struct Gadget *)Massage -> IAddress;

					GT_ReplyIMsg(Massage);

					if(Class == IDCMP_VANILLAKEY)
						KeySelect(GadgetArray,GAD_CANCEL,Code,PanelWindow,&Gadget,&Class,&Code);

					if(Class == IDCMP_GADGETDOWN)
					{
						if((Gadget -> GadgetType & GTYP_GTYPEMASK) == GTYP_STRGADGET)
							ActiveGadget = Gadget;
					}

					if(Class == IDCMP_ACTIVEWINDOW && ActiveGadget)
						ActivateGadget(ActiveGadget,PanelWindow,NULL);

					if(Class == IDCMP_CLOSEWINDOW)
					{
						Terminated = TRUE;

						Config -> Priority = PrivateConfig . Priority;
					}

					if(Class == IDCMP_MOUSEMOVE)
					{
						switch(Gadget -> GadgetID)
						{
							case GAD_PRIORITY:	Config -> Priority = (BYTE)Code;
										break;

							case GAD_CHARDELAY:	Config -> CharDelay = Code;
										break;

							case GAD_LINEDELAY:	Config -> LineDelay = Code;
										break;
						}
					}

					if(Class == IDCMP_GADGETUP)
					{
						switch(Gadget -> GadgetID)
						{
							case GAD_PRIORITY:	Config -> Priority = (BYTE)Code;
										break;

							case GAD_CHARDELAY:	Config -> CharDelay = Code;
										break;

							case GAD_LINEDELAY:	Config -> LineDelay = Code;
										break;

							case GAD_USE:		Terminated = TRUE;

										Config -> OverridePath		= GT_CHECKED(GadgetArray[GAD_OVERRIDE]);
										Config -> BackupConfig		= GT_CHECKED(GadgetArray[GAD_BACKUP]);
										Config -> AutoUpload		= GT_CHECKED(GadgetArray[GAD_AUTOUPLOAD]);
										Config -> SetArchivedBit	= GT_CHECKED(GadgetArray[GAD_SETBIT]);
										Config -> BufferEnabled		= GT_CHECKED(GadgetArray[GAD_BUFFERENABLED]);
										Config -> OpenFastMacroPanel	= GT_CHECKED(GadgetArray[GAD_SHOWFASTMACROS]);
										Config -> MaxLogBuffSize	= GT_INTEGER(GadgetArray[GAD_MAXBUFFSIZE]);
										Config -> ClipboardUnit		= GT_INTEGER(GadgetArray[GAD_CLIPBOARD]);

										if(Config -> ClipboardUnit < 0)
											Config -> ClipboardUnit = 0;

										if(GT_INTEGER(GadgetArray[GAD_CLIPBOARD]) > 255)
											Config -> ClipboardUnit = 255;

										if(Config -> MaxLogBuffSize && Config -> MaxLogBuffSize < 2000)
											Config -> MaxLogBuffSize = 2000;

										break;

							case GAD_CANCEL:	Terminated = TRUE;

										Config -> Priority = PrivateConfig . Priority;

										break;

							default:		break;
						}
					}
				}
			}

			RemoveGList(PanelWindow,GadgetList,(UWORD)-1);

			PopWindow();

			CloseWindow(PanelWindow);
		}
	}

	FreeGadgets(GadgetList);
}
