/*
**	$Id: ModemPanel.c,v 1.11 92/08/18 16:11:28 olsen Sta Locker: olsen $
**	$Revision: 1.11 $
**	$Date: 92/08/18 16:11:28 $
**
**	Editing panel for modem configuration
**
**	Copyright  1990-1992 by Olaf `Olsen' Barthel & MXM
**		All Rights Reserved
*/

#include "termGlobal.h"

enum	{	GAD_MODEMINIT,GAD_MODEMEXIT,GAD_MODEMHANGUP,GAD_DIALPREFIX,GAD_DIALSUFFIX,GAD_NOCARRIER,
		GAD_NODIALTONE,GAD_CONNECT,GAD_VOICE,GAD_RING,GAD_BUSY,
		GAD_REDIALDELAY,GAD_DIALRETRIES,GAD_DIALTIMEOUT,GAD_AUTOCAPTURE,
		GAD_AUTOBAUD,GAD_LOG,GAD_CHECK,GAD_DROPDTR,GAD_PASSTHROUGH,GAD_CALLINFO,GAD_USE,GAD_CANCEL };

STATIC UBYTE * __saveds
ShowMinutes(struct Gadget *SomeGadget,WORD Level)
{
	STATIC UBYTE Buffer[15];

	SPrintf(Buffer,LocaleString(MSG_GLOBAL_SHOW_MINUTES_TXT),Level / 6,(Level % 6) * 10);

	return(Buffer);
}

STATIC UBYTE * __saveds
ShowSeconds(struct Gadget *SomeGadget,WORD Level)
{
	STATIC UBYTE Buffer[15];

	SPrintf(Buffer,LocaleString(MSG_GLOBAL_SHOW_MINUTES_TXT),Level / 60,Level % 60);

	return(Buffer);
}

STATIC struct Gadget *
CreateAllGadgets(struct Configuration *Config,struct Gadget **GadgetArray,struct Gadget **GadgetList,APTR VisualInfo,UWORD TopEdge)
{
	struct Gadget		*Gadget;
	struct NewGadget	 NewGadget;
	UWORD			 Counter = 0;

	SZ_SizeSetup(Screen,&UserFont,TRUE);

	memset(&NewGadget,0,sizeof(struct NewGadget));

	if(Gadget = CreateContext(GadgetList))
	{
		SZ_AddLeftOffset(SZ_LeftOffsetDelta(MSG_MODEMPANEL_MODEM_INIT_STRING_GAD,MSG_MODEMPANEL_BUSY_STRING_GAD));

		SZ_ResetMaxWidth();

		SZ_UpdateMaxWidth(STRING_KIND,NULL,18,NULL);

		SZ_SetWidth(SZ_ResetMaxWidth());

		NewGadget . ng_GadgetText	= LocaleString(MSG_MODEMPANEL_MODEM_INIT_STRING_GAD);
		NewGadget . ng_TextAttr		= &UserFont;
		NewGadget . ng_VisualInfo	= VisualInfo;
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			SZ_Adjust,		TRUE,
			SZ_AutoWidth,		TRUE,

			GT_Underscore,	'_',
			GTST_MaxChars,	79,
			GTST_String,	Config -> ModemInit,
			GTST_EditHook,	&CommandHook,
			GA_Immediate,	TRUE,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_MODEMPANEL_MODEM_EXIT_STRING_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			SZ_Adjust,		TRUE,
			SZ_AutoWidth,		TRUE,

			GT_Underscore,	'_',
			GTST_MaxChars,	79,
			GTST_String,	Config -> ModemExit,
			GTST_EditHook,	&CommandHook,
			GA_Immediate,	TRUE,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_MODEMPANEL_MODEM_HANGUP_STRING_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			SZ_Adjust,		TRUE,
			SZ_AutoWidth,		TRUE,

			GT_Underscore,	'_',
			GTST_MaxChars,	79,
			GTST_String,	Config -> ModemHangup,
			GTST_EditHook,	&CommandHook,
			GA_Immediate,	TRUE,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_MODEMPANEL_DIAL_PREFIX_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			SZ_Adjust,		TRUE,
			SZ_AutoWidth,		TRUE,

			GT_Underscore,	'_',
			GTST_MaxChars,	79,
			GTST_String,	Config -> DialPrefix,
			GTST_EditHook,	&CommandHook,
			GA_Immediate,	TRUE,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_MODEMPANEL_DIAL_SUFFIX_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			SZ_Adjust,		TRUE,
			SZ_AutoWidth,		TRUE,

			GT_Underscore,	'_',
			GTST_MaxChars,	79,
			GTST_String,	Config -> DialSuffix,
			GTST_EditHook,	&CommandHook,
			GA_Immediate,	TRUE,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_MODEMPANEL_NO_CARRIER_STRING_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			SZ_Adjust,		TRUE,
			SZ_AutoWidth,		TRUE,

			GT_Underscore,	'_',
			GTST_MaxChars,	15,
			GTST_String,	Config -> NoCarrier,
			GTST_EditHook,	&CommandHook,
			GA_Immediate,	TRUE,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_MODEMPANEL_NO_DIALTONE_STRING_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			SZ_Adjust,		TRUE,
			SZ_AutoWidth,		TRUE,

			GT_Underscore,	'_',
			GTST_MaxChars,	15,
			GTST_String,	Config -> NoDialTone,
			GTST_EditHook,	&CommandHook,
			GA_Immediate,	TRUE,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_MODEMPANEL_CONNECT_STRING_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			SZ_Adjust,		TRUE,
			SZ_AutoWidth,		TRUE,

			GT_Underscore,	'_',
			GTST_MaxChars,	15,
			GTST_String,	Config -> Connect,
			GTST_EditHook,	&CommandHook,
			GA_Immediate,	TRUE,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_MODEMPANEL_VOICE_STRING_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			SZ_Adjust,		TRUE,
			SZ_AutoWidth,		TRUE,

			GT_Underscore,	'_',
			GTST_MaxChars,	15,
			GTST_String,	Config -> Voice,
			GTST_EditHook,	&CommandHook,
			GA_Immediate,	TRUE,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_MODEMPANEL_RING_STRING_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			SZ_Adjust,		TRUE,
			SZ_AutoWidth,		TRUE,

			GT_Underscore,	'_',
			GTST_MaxChars,	15,
			GTST_String,	Config -> Ring,
			GTST_EditHook,	&CommandHook,
			GA_Immediate,	TRUE,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_MODEMPANEL_BUSY_STRING_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			SZ_Adjust,		TRUE,
			SZ_AutoWidth,		TRUE,

			GT_Underscore,	'_',
			GTST_MaxChars,	15,
			GTST_String,	Config -> Busy,
			GTST_EditHook,	&CommandHook,
			GA_Immediate,	TRUE,
		TAG_DONE);

		SZ_SetWidth(90);

		SZ_AddLeftOffset(SZ_LeftOffsetDelta(MSG_MODEMPANEL_REDIAL_DELAY_GAD,MSG_MODEMPANEL_PASS_XON_XOFF_THROUGH_GAD));

		NewGadget . ng_GadgetText	= LocaleString(MSG_MODEMPANEL_REDIAL_DELAY_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(SLIDER_KIND,Gadget,&NewGadget,
			SZ_Adjust,		TRUE,
			SZ_AutoWidth,		TRUE,
			SZ_NewColumn,		TRUE,

			GT_Underscore,		'_',
			GTSL_Min,		0,
			GTSL_Max,		360,
			GTSL_Level,		Config -> RedialDelay,
			GTSL_DispFunc,		ShowMinutes,
			GTSL_LevelFormat,	"%s",
			GTSL_MaxLevelLen,	11,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_MODEMPANEL_DIAL_RETRIES_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(SLIDER_KIND,Gadget,&NewGadget,
			SZ_Adjust,		TRUE,
			SZ_AutoWidth,		TRUE,

			GT_Underscore,		'_',
			GTSL_Min,		0,
			GTSL_Max,		100,
			GTSL_Level,		Config -> DialRetries,
			GTSL_LevelFormat,	"%3ld",
			GTSL_MaxLevelLen,	3,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_MODEMPANEL_DIAL_TIMEOUT_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(SLIDER_KIND,Gadget,&NewGadget,
			SZ_Adjust,		TRUE,
			SZ_AutoWidth,		TRUE,

			GT_Underscore,		'_',
			GTSL_Min,		0,
			GTSL_Max,		1800,
			GTSL_Level,		Config -> DialTimeout,
			GTSL_DispFunc,		ShowSeconds,
			GTSL_LevelFormat,	"%s",
			GTSL_MaxLevelLen,	11,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_MODEMPANEL_CONNECT_AUTO_CAPTURE_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(CHECKBOX_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,

			GT_Underscore,	'_',
			GTCB_Checked,	Config -> ConnectAutoCapture,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_MODEMPANEL_CONNECT_AUTO_BAUD_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(CHECKBOX_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,

			GT_Underscore,	'_',
			GTCB_Checked,	Config -> ConnectAutoBaud,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_MODEMPANEL_LOG_ACTIONS_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(CHECKBOX_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,

			GT_Underscore,	'_',
			GTCB_Checked,	Config -> LogActions,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_MODEMPANEL_CHECK_CARRIER_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(CHECKBOX_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,

			GT_Underscore,	'_',
			GTCB_Checked,	Config -> CheckCarrier,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_MODEMPANEL_DROP_DTR_ON_HANGUP_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(CHECKBOX_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,

			GT_Underscore,	'_',
			GTCB_Checked,	Config -> DropDTR,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_MODEMPANEL_PASS_XON_XOFF_THROUGH_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(CHECKBOX_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,

			GT_Underscore,	'_',
			GTCB_Checked,	Config -> PassThrough,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_MODEMPANEL_CREATE_CALL_INFO_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(CHECKBOX_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,

			GT_Underscore,	'_',
			GTCB_Checked,	Config -> NCommLog,
		TAG_DONE);

		SZ_UpdateMaxWidth(BUTTON_KIND,LocaleString(MSG_GLOBAL_USE_GAD),0,NULL);
		SZ_UpdateMaxWidth(BUTTON_KIND,LocaleString(MSG_GLOBAL_CANCEL_GAD),0,NULL);

		SZ_SetWidth(SZ_ResetMaxWidth());

		NewGadget . ng_GadgetText	= LocaleString(MSG_GLOBAL_USE_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(BUTTON_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,
			SZ_AlignExtra,	TRUE,
			SZ_AlignLeft,	TRUE,
			SZ_AlignBottom,	TRUE,

			GT_Underscore,	'_',
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_GLOBAL_CANCEL_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(BUTTON_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,
			SZ_AlignRight,	TRUE,

			GT_Underscore,	'_',
		TAG_DONE);
	}

	return(Gadget);
}

BYTE
ModemPanel(struct Configuration *Config)
{
	struct Window	*PanelWindow;
	struct Gadget	*GadgetList = NULL;
	struct Gadget	*GadgetArray[GAD_CANCEL + 1];

	CopyMem(Config,&PrivateConfig,sizeof(struct Configuration));

	if(CreateAllGadgets(Config,&GadgetArray[0],&GadgetList,VisualInfo,Screen -> WBorTop + Screen -> Font -> ta_YSize + 1))
	{
		if(PanelWindow = OpenWindowTags(NULL,
			WA_Left,	(Screen -> Width	- SZ_GetWindowWidth())	/ 2,
			WA_Top,		(Screen -> Height	- SZ_GetWindowHeight())	/ 2,
			WA_Width,	SZ_GetWindowWidth(),
			WA_Height,	SZ_GetWindowHeight(),

			WA_Activate,	TRUE,
			WA_DragBar,	TRUE,
			WA_DepthGadget,	TRUE,
			WA_RMBTrap,	TRUE,
			WA_DepthGadget,	TRUE,
			WA_CloseGadget,	TRUE,
			WA_CustomScreen,Screen,

			WA_IDCMP,	IDCMP_GADGETDOWN | IDCMP_ACTIVEWINDOW | IDCMP_CLOSEWINDOW | IDCMP_VANILLAKEY | SLIDERIDCMP | CHECKBOXIDCMP | STRINGIDCMP | BUTTONIDCMP,

			WA_Title,	LocaleString(MSG_MODEMPANEL_MODEM_PREFERENCES_TXT),
		TAG_DONE))
		{
			struct IntuiMessage	*Massage;
			ULONG			 Class,Code;
			struct Gadget		*Gadget;
			BYTE			 Terminated = FALSE;

			PushWindow(PanelWindow);

			AddGList(PanelWindow,GadgetList,(UWORD)-1,(UWORD)-1,NULL);
			RefreshGList(GadgetList,PanelWindow,NULL,(UWORD)-1);
			GT_RefreshWindow(PanelWindow,NULL);

			ActiveGadget = NULL;

			while(!Terminated)
			{
				WaitPort(PanelWindow -> UserPort);

				while(!Terminated && (Massage = (struct IntuiMessage *)GT_GetIMsg(PanelWindow -> UserPort)))
				{
					Class	= Massage -> Class;
					Code	= Massage -> Code;
					Gadget	= (struct Gadget *)Massage -> IAddress;

					GT_ReplyIMsg(Massage);

					if(Class == IDCMP_VANILLAKEY)
						KeySelect(GadgetArray,GAD_CANCEL,Code,PanelWindow,&Gadget,&Class,&Code);

					if(Class == IDCMP_ACTIVEWINDOW && ActiveGadget)
						ActivateGadget(ActiveGadget,PanelWindow,NULL);

					if(Class == IDCMP_GADGETDOWN)
					{
						if((Gadget -> GadgetType & GTYP_GTYPEMASK) == GTYP_STRGADGET)
							ActiveGadget = Gadget;
					}

					if(Class == IDCMP_CLOSEWINDOW)
						Terminated = TRUE;

					if(Class == IDCMP_MOUSEMOVE)
					{
						switch(Gadget -> GadgetID)
						{
							case GAD_REDIALDELAY:	Config -> RedialDelay = Code;
										break;

							case GAD_DIALRETRIES:	Config -> DialRetries = Code;
										break;

							case GAD_DIALTIMEOUT:	Config -> DialTimeout = Code;
										break;

							default:		break;
						}
					}

					if(Class == IDCMP_GADGETUP)
					{
						switch(Gadget -> GadgetID)
						{
							case GAD_USE:		Terminated = TRUE;

										strcpy(Config -> ModemInit,	GT_STRING(GadgetArray[GAD_MODEMINIT]));
										strcpy(Config -> ModemExit,	GT_STRING(GadgetArray[GAD_MODEMEXIT]));
										strcpy(Config -> ModemHangup,	GT_STRING(GadgetArray[GAD_MODEMHANGUP]));
										strcpy(Config -> DialPrefix,	GT_STRING(GadgetArray[GAD_DIALPREFIX]));
										strcpy(Config -> DialSuffix,	GT_STRING(GadgetArray[GAD_DIALSUFFIX]));
										strcpy(Config -> NoCarrier,	GT_STRING(GadgetArray[GAD_NOCARRIER]));
										strcpy(Config -> NoDialTone,	GT_STRING(GadgetArray[GAD_NODIALTONE]));
										strcpy(Config -> Connect,	GT_STRING(GadgetArray[GAD_CONNECT]));
										strcpy(Config -> Voice,		GT_STRING(GadgetArray[GAD_VOICE]));
										strcpy(Config -> Ring,		GT_STRING(GadgetArray[GAD_RING]));
										strcpy(Config -> Busy,		GT_STRING(GadgetArray[GAD_BUSY]));

										Config -> ConnectAutoCapture	= GT_CHECKED(GadgetArray[GAD_AUTOCAPTURE]);
										Config -> ConnectAutoBaud	= GT_CHECKED(GadgetArray[GAD_AUTOBAUD]);
										Config -> LogActions		= GT_CHECKED(GadgetArray[GAD_LOG]);
										Config -> CheckCarrier		= GT_CHECKED(GadgetArray[GAD_CHECK]);
										Config -> DropDTR		= GT_CHECKED(GadgetArray[GAD_DROPDTR]);
										Config -> PassThrough		= GT_CHECKED(GadgetArray[GAD_PASSTHROUGH]);
										Config -> NCommLog		= GT_CHECKED(GadgetArray[GAD_CALLINFO]);

										break;

							case GAD_CANCEL:	Terminated = TRUE;

										CopyMem(&PrivateConfig,Config,sizeof(struct Configuration));

										break;

							default:		break;
						}
					}
				}
			}

			RemoveGList(PanelWindow,GadgetList,(UWORD)-1);

			PopWindow();

			CloseWindow(PanelWindow);
		}
	}

	FreeGadgets(GadgetList);

	if(memcmp(&PrivateConfig,Config,sizeof(struct Configuration)))
		return(TRUE);
	else
		return(FALSE);
}
